# Generated by rust2rpm 27
%bcond check 1
%global debug_package %{nil}

%global crate jiff

Name:           rust-jiff
Version:        0.2.13
Release:        %mkrel 1
Summary:        Date-time library that encourages you to jump into the pit of success

Group:          Development/Rust
BuildArch:      noarch

License:        Unlicense OR MIT
URL:            https://crates.io/crates/jiff
Source:         %{crates_source}
# * Since 0.1.22, the published crates no longer include “non-essential files
#   (including tests and test data).” Since we would like to run the tests, we
#   use the GitHub archive as an additonal source as permitted in
#   https://docs.fedoraproject.org/en-US/packaging-guidelines/Rust/#_package_sources,
#   waiting until %%check to copy in the extra files to prove they are not
#   included in the crate sources shipped in the binary RPMs.
Source10:       https://github.com/BurntSushi/jiff/archive/%{version}/jiff-%{version}.tar.gz
# Automatically generated patch to strip dependencies and normalize metadata
Patch:          jiff-fix-metadata-auto.diff
# Manually created patch for downstream crate metadata changes
# * Patch out the "js" feature, which is for wasm/browser targets only; rust2rpm
#   already patches the dependencies out of this feature automatically.
# * Patch out the optional jiff-static and jiff-tzdb dependencies and all
#   features that would require them ("jiff-static", "static", "static-tz",
#   "jiff-tzdb", and "tzdb-bundle-always"). These crates are for compiling
#   timezone database data into the binary. We do not want to package either
#   crate, and we do not see a good use case for static time zone databases in
#   distribution packages, which are much better off using the system timezone
#   database in general.
# * Drop dev-dependency hifitime: not packaged, and only for doctests
Patch:          jiff-fix-metadata.diff
Patch:          jiff-fix-metadata2.diff
# * Downstream-only: Omit doctests that require hifitime. It is not worth
#   packaging it solely for a couple of tiny examples.
Patch10:        0001-Downstream-only-Omit-doctests-that-require-hifitime.patch
# * Downstream-only: Omit doctests that require jiff-static
Patch11:        0001-Downstream-only-Omit-doctests-that-require-jiff-stat.patch

BuildRequires:  cargo-rpm-macros >= 24

%global _description %{expand:
A date-time library that encourages you to jump into the pit of success.
This library is heavily inspired by the Temporal project.}

%description %{_description}

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/COPYING
%license %{crate_instdir}/LICENSE-MIT
%license %{crate_instdir}/UNLICENSE
%doc %{crate_instdir}/CHANGELOG.md
%doc %{crate_instdir}/COMPARE.md
%doc %{crate_instdir}/DESIGN.md
%doc %{crate_instdir}/PLATFORM.md
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+alloc-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+alloc-devel %{_description}

This package contains library source intended for building other packages which
use the "alloc" feature of the "%{crate}" crate.

%files       -n %{name}+alloc-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+logging-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+logging-devel %{_description}

This package contains library source intended for building other packages which
use the "logging" feature of the "%{crate}" crate.

%files       -n %{name}+logging-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+perf-inline-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+perf-inline-devel %{_description}

This package contains library source intended for building other packages which
use the "perf-inline" feature of the "%{crate}" crate.

%files       -n %{name}+perf-inline-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serde-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serde-devel %{_description}

This package contains library source intended for building other packages which
use the "serde" feature of the "%{crate}" crate.

%files       -n %{name}+serde-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+std-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+std-devel %{_description}

This package contains library source intended for building other packages which
use the "std" feature of the "%{crate}" crate.

%files       -n %{name}+std-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tz-fat-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tz-fat-devel %{_description}

This package contains library source intended for building other packages which
use the "tz-fat" feature of the "%{crate}" crate.

%files       -n %{name}+tz-fat-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tz-system-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tz-system-devel %{_description}

This package contains library source intended for building other packages which
use the "tz-system" feature of the "%{crate}" crate.

%files       -n %{name}+tz-system-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tzdb-bundle-platform-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tzdb-bundle-platform-devel %{_description}

This package contains library source intended for building other packages which
use the "tzdb-bundle-platform" feature of the "%{crate}" crate.

%files       -n %{name}+tzdb-bundle-platform-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tzdb-concatenated-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tzdb-concatenated-devel %{_description}

This package contains library source intended for building other packages which
use the "tzdb-concatenated" feature of the "%{crate}" crate.

%files       -n %{name}+tzdb-concatenated-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+tzdb-zoneinfo-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tzdb-zoneinfo-devel %{_description}

This package contains library source intended for building other packages which
use the "tzdb-zoneinfo" feature of the "%{crate}" crate.

%files       -n %{name}+tzdb-zoneinfo-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires -f serde

%build
%cargo_build -f serde

%install
%cargo_install -f serde

%if %{with check}
%check
# Copy in snapshots, integration tests, and test data – required to run tests,
# but not included in the released crate. By doing so here in %%check rather
# than in %%prep, we prove that the binary RPMs are derived solely from the
# published crate sources.
tar -xzvf '%{SOURCE10}' --strip-components=1 \
    jiff-%{version}/src/tz/snapshots \
    jiff-%{version}/src/tz/testdata \
    jiff-%{version}/tests
# These tests would require the "static"/"static-tz" features:
rm -rv tests/procmacro/
sed -r -i 's@^mod procmacro;@// &@' tests/lib.rs
%cargo_test -f serde
%endif



%changelog
* Sun May 18 2025 wally <wally> 0.2.13-1.mga10
+ Revision: 2184480
- new version 0.2.13
- update RPM group to Development/Rust

* Mon Oct 21 2024 wally <wally> 0.1.13-1.mga10
+ Revision: 2109456
- mageiafy .spec
- imported package rust-jiff


## START: Generated by rpmautospec
* Thu Sep 19 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.13-2
- On EPEL9, disable doctests that require a newer Rust compiler

* Sun Sep 08 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.13-1
- Update to 0.1.13 (close RHBZ#2310620)

* Mon Sep 02 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.12-1
- Update to 0.1.12 (close RHBZ#2309076)

* Sat Aug 24 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.10-1
- Update to 0.1.10

* Sat Aug 24 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.8-3
- Stop allowing chrono-tz 0.8, since we have 0.9

* Sat Aug 24 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.8-1
- Initial package (close RHBZ#2307325)
## END: Generated by rpmautospec
